package com.hzya.frame.grpU8.acctVouchInfo.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.grpU8.nxproof.glPzml.dao.ISenderGlPzmlDao;
import com.hzya.frame.grpU8.nxproof.glPzml.entity.SenderGlPzmlEntity;
import com.hzya.frame.grpU8.nxproof.glPznr.dao.ISenderGlPznrDao;
import com.hzya.frame.grpU8.nxproof.glPznr.entity.SenderGlPznrEntity;
import com.hzya.frame.grpU8.nxproof.glfzxzl.dao.IGlFzxzlDao;
import com.hzya.frame.grpU8.nxproof.glfzxzl.entity.GlFzxzlEntityDto;
import com.hzya.frame.grpU8.nxproof.glfzxzl.entity.GlFzxzlNrDmEntityDto;
import com.hzya.frame.grpU8.nxproof.glfzxzl.entity.GlFzxzlNrEntityDto;
import com.hzya.frame.sysnew.application.database.dao.ISysApplicationDatabaseDao;
import com.hzya.frame.sysnew.application.database.entity.SysApplicationDatabaseEntity;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.sysnew.user.entity.SysUserEntity;
import com.hzya.frame.util.bipV3.SHA256Util;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import com.hzya.frame.grpU8.acctVouchInfo.entity.AcctVouchInfoEntity;
import com.hzya.frame.grpU8.acctVouchInfo.dao.IAcctVouchInfoDao;
import com.hzya.frame.grpU8.acctVouchInfo.entity.AcctVouchInfoEntityVo;
import com.hzya.frame.grpU8.acctVouchInfo.service.IAcctVouchInfoService;
import org.apache.commons.lang3.StringUtils;
import org.bson.json.JsonObject;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import javax.annotation.Resource;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 子表(AcctVouchInfo)表服务实现类
 *
 * @author makejava
 * @since 2024-07-09 11:25:15
 */
@Service(value = "acctVouchInfoService")
public class AcctVouchInfoServiceImpl extends BaseService<AcctVouchInfoEntity, String> implements IAcctVouchInfoService {
     
    private IAcctVouchInfoDao acctVouchInfoDao;

    @Resource
    private ISysApplicationDatabaseDao sysApplicationDatabaseDao;
	@Resource
	private ISenderGlPzmlDao senderGlPzmlDao;
	@Resource
	private ISenderGlPznrDao senderGlPznrDao;
	@Resource
	private IGlFzxzlDao glFzxzlDao;
    @Autowired
	public void setAcctVouchInfoDao(IAcctVouchInfoDao dao) {
		this.acctVouchInfoDao = dao;
		this.dao = dao;
	}

	/**
	 * @param jsonObject
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 * @Author lvleigang
	 * @Description 数据表
	 * @Date 11:52 上午 2024/3/27
	 **/
	@Override
	public Object queryData(JSONObject jsonObject) {
		AcctVouchInfoEntity entity = getData("jsonStr", jsonObject, AcctVouchInfoEntity.class);
		if(entity == null ){
			entity = new AcctVouchInfoEntity();
		}
		//判断分页
		if (entity.getPageNum() != null && entity.getPageSize() != null) {
			PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
			List<AcctVouchInfoEntityVo> list = acctVouchInfoDao.queryData(entity);
			PageInfo pageInfo = new PageInfo(list);
			JSONObject object = new JSONObject();
			object.put("status","success");
			object.put("data",pageInfo);
			return object;
		}else {
			List<AcctVouchInfoEntityVo> list = acctVouchInfoDao.queryData(entity);
			JSONObject object = new JSONObject();
			object.put("status","success");
			object.put("data",list);
			return object;
		}
	}

	/**
	 * @param entity
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 * @Author lvleigang
	 * @Description 数据表
	 * @Date 11:52 上午 2024/3/27
	 **/
	@Override
	public SysExtensionApiEntity addDataSourceCode(SysExtensionApiEntity entity) {
		try {
			SysApplicationEntity applicationEntity = entity.getReceiveApp();
			SysApplicationDatabaseEntity sysApplicationDatabaseEntity = new SysApplicationDatabaseEntity();
			sysApplicationDatabaseEntity.setSts("Y");
			sysApplicationDatabaseEntity.setDbStatus("1");
			sysApplicationDatabaseEntity.setAppId(applicationEntity.getId());
			sysApplicationDatabaseEntity.setDataSourceCode("master");
			List<SysApplicationDatabaseEntity> sysDataSourceEntities = sysApplicationDatabaseDao.queryDSBase(sysApplicationDatabaseEntity);
			if(sysDataSourceEntities != null && sysDataSourceEntities.size() > 0){
				String parm = entity.getBodys();
				JSONObject jsonObject = JSONObject.parseObject(parm);
				jsonObject.put("dataSourceCode",sysDataSourceEntities.get(0).getSourceCode());
				entity.setBodys(jsonObject.toJSONString());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return entity;
	}

	/**
	 * @param object
	 * @return java.lang.Object
	 * @Author lvleigang
	 * @Description 查询凭证目录
	 * @Date 1:48 下午 2024/8/27
	 **/
	@Override
	public Object queryPzml(JSONObject object) {
		SenderGlPzmlEntity entity = getData("jsonStr", object,SenderGlPzmlEntity.class);
		//判断分页
		if (entity.getPageNum() != null && entity.getPageSize() != null) {
			PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
			List<SenderGlPzmlEntity> list = senderGlPzmlDao.querySenderGlPzmlEntity(entity);
			PageInfo pageInfo = new PageInfo(list);
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",pageInfo);
			returnObject.put("msg","查询成功");

			return returnObject;
		}else {
			List<SenderGlPzmlEntity> list = senderGlPzmlDao.querySenderGlPzmlEntity(entity);
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",list);
			returnObject.put("msg","查询成功");

			return returnObject;
		}
	}
	/**
	 * @param object
	 * @return java.lang.Object
	 * @Author lvleigang
	 * @Description 查询凭证内容
	 * @Date 1:48 下午 2024/8/27
	 **/
	@Override
	public Object queryPznr(JSONObject object) {
		SenderGlPznrEntity entity = getData("jsonStr", object,SenderGlPznrEntity.class);
		//判断分页
		if (entity.getPageNum() != null && entity.getPageSize() != null) {
			PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
			List<SenderGlPznrEntity> list = senderGlPznrDao.querySenderGlPznrEntity(entity);
			PageInfo pageInfo = new PageInfo(list);
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",pageInfo);
			returnObject.put("msg","查询成功");

			return returnObject;
		}else {
			List<SenderGlPznrEntity> list = senderGlPznrDao.querySenderGlPznrEntity(entity);
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",list);
			returnObject.put("msg","查询成功");

			return returnObject;
		}
	}

	/**
	 * @param object
	 * @return java.lang.Object
	 * @Author lvleigang
	 * @Description 查询凭证 目录 内容 辅助核算
	 * @Date 1:48 下午 2024/8/27
	 **/
	@Override
	public Object queryPz(JSONObject object) {
		SenderGlPzmlEntity entity = getData("jsonStr", object,SenderGlPzmlEntity.class);
		//判断分页
		if (entity.getIdpzh() != null && !"".equals(entity.getIdpzh())) {
			//查询凭证目录
			SenderGlPzmlEntity senderGlPzmlEntity = senderGlPzmlDao.queryPzmlByIdpzh(entity);
			if(senderGlPzmlEntity.getIdpzh() != null && !"".equals(senderGlPzmlEntity.getIdpzh())){
				//查询凭证内容
				SenderGlPznrEntity senderGlPznrEntity = new SenderGlPznrEntity();
				senderGlPznrEntity.setDataSourceCode(entity.getDataSourceCode());
				senderGlPznrEntity.setIdpzh(entity.getIdpzh());
				List<SenderGlPznrEntity> list = senderGlPznrDao.querySenderGlPznrEntityByIdpzh(senderGlPznrEntity);
				senderGlPzmlEntity.setSenderGlPznrEntities(list);
				//查询辅助核算
				if(list != null && list.size() > 0){
					GlFzxzlEntityDto glFzxzlEntityDto = new GlFzxzlEntityDto();
					glFzxzlEntityDto.setDataSourceCode(entity.getDataSourceCode());
					glFzxzlEntityDto.setSfyz("0");
					List<GlFzxzlNrEntityDto> glFzxzlNrEntityDtos = new ArrayList<>();
					for (int i = 0; i < list.size(); i++) {
						if(list.get(i).getKjqj() != null && list.get(i).getKjqj().length() >= 4){
							GlFzxzlNrEntityDto glFzxzlNrEntityDto = new GlFzxzlNrEntityDto();
							glFzxzlNrEntityDto.setGsdm(list.get(i).getGsdm());
							glFzxzlNrEntityDto.setKjnd(list.get(i).getKjqj().substring(0,4));
							List<GlFzxzlNrDmEntityDto> glFzxzlNrDmEntityDtos = new ArrayList<>();

							if(list.get(i).getFzhs() != null && !"".equals(list.get(i).getFzhs())){
								JSONObject jsonObject = (JSONObject) JSONObject.toJSON(list.get(i));
								String[] fzhs = list.get(i).getFzhs().split(",");
								if(fzhs != null && fzhs.length > 0){
									for (int i1 = 0; i1 < fzhs.length; i1++) {
										if(fzhs[i1] != null && !"".equals(fzhs[i1])){
											if(jsonObject.get("fzdm"+fzhs[i1]) != null && !"".equals(jsonObject.get("fzdm"+fzhs[i1]))){
												GlFzxzlNrDmEntityDto glFzxzlNrDmEntityDto = new GlFzxzlNrDmEntityDto();
												glFzxzlNrDmEntityDto.setLbdm(fzhs[i1]);
												glFzxzlNrDmEntityDto.setFzdm(jsonObject.getString("fzdm"+fzhs[i1]));
												glFzxzlNrDmEntityDtos.add(glFzxzlNrDmEntityDto);
											}
										}
									}
								}
							}
							if(glFzxzlNrDmEntityDtos.size() > 0){
								glFzxzlNrEntityDto.setGlFzxzlNrDmEntityDtos(glFzxzlNrDmEntityDtos);
								glFzxzlNrEntityDtos.add(glFzxzlNrEntityDto);
							}
						}
					}
					if(glFzxzlNrEntityDtos.size() > 0) {
						glFzxzlEntityDto.setGlFzxzlNrEntityDtos(glFzxzlNrEntityDtos);
						// 查询数据，设置值
						List<JSONObject> fzhss = glFzxzlDao.queryFzhs(glFzxzlEntityDto);
						if(fzhss != null && fzhss.size() > 0){
							for (int i = 0; i < list.size(); i++) {
								List<JSONObject> fzhslist = new ArrayList<>();
								list.get(i).setFzhslist(fzhslist);
								if (list.get(i).getKjqj() != null && list.get(i).getKjqj().length() >= 4) {
									if (list.get(i).getFzhs() != null && !"".equals(list.get(i).getFzhs())) {
										JSONObject jsonObject = (JSONObject) JSONObject.toJSON(list.get(i));
										String[] fzhs = list.get(i).getFzhs().split(",");
										if (fzhs != null && fzhs.length > 0) {
											for (int i1 = 0; i1 < fzhs.length; i1++) {
												if (fzhs[i1] != null && !"".equals(fzhs[i1])) {
													if (jsonObject.get("fzdm" + fzhs[i1]) != null && !"".equals(jsonObject.get("fzdm" + fzhs[i1]))) {
														for (int i2 = 0; i2 < fzhss.size(); i2++) {
															if(fzhss.get(i2).getString("lbdm").equals(fzhs[i1])
																&&	fzhss.get(i2).getString("gsdm").equals(list.get(i).getGsdm())
																&&	fzhss.get(i2).getString("kjnd").equals(list.get(i).getKjqj().substring(0,4))
																&&	fzhss.get(i2).getString("fzdm").equals(jsonObject.get("fzdm" + fzhs[i1]))
															){
																JSONObject a = new JSONObject();
																a.put("lbdm",fzhss.get(i2).getString("lbdm"));
																a.put("fzdm",fzhss.get(i2).getString("fzdm"));
																a.put("fzmc",fzhss.get(i2).getString("fzmc"));
																fzhslist.add(a);
															}

														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}else {
				JSONObject returnObject = new JSONObject();
				returnObject.put("status","false");
				returnObject.put("msg","查询错误，根据idpzh未查询到凭证");
				return returnObject;
			}
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",senderGlPzmlEntity);
			returnObject.put("msg","查询成功");
			return returnObject;
		}else {
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","false");
			returnObject.put("msg","查询错误，idpzh为空");
			return returnObject;
		}
	}

	@Override
	public Object queryPzPage(JSONObject object) {
		SenderGlPzmlEntity entity = getData("jsonStr", object,SenderGlPzmlEntity.class);
		//判断分页
		if (entity.getPageNum() != null && entity.getPageSize() != null) {
			PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
			List<SenderGlPzmlEntity> list = senderGlPzmlDao.querySenderGlPzmlEntity(entity);
			PageInfo pageInfo = new PageInfo(list);
			doPznrAndPzmlFzhs(list,entity.getDataSourceCode());
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","success");
			returnObject.put("data",pageInfo);
			returnObject.put("msg","查询成功");
			return returnObject;
		}else {
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","false");
			returnObject.put("msg","请先传递分页参数");
			return returnObject;
		}
	}

	/**
	 * @Author lvleigang
	 * @Description  处理凭证内容和辅助核算
	 * @Date 2:15 下午 2024/8/29
	 * @param senderGlPzmlEntities
	 * @param dataSourceCode
	 * @return void
	 **/
	private void doPznrAndPzmlFzhs(List<SenderGlPzmlEntity> senderGlPzmlEntities, String dataSourceCode) {
		if(senderGlPzmlEntities == null || senderGlPzmlEntities.size() == 0 ){
			return;
		}
		//查询凭证内容
		List<String> idpzhs = new ArrayList<>();
		for (int i = 0; i < senderGlPzmlEntities.size(); i++) {
			idpzhs.add(senderGlPzmlEntities.get(i).getIdpzh());
		}
		SenderGlPznrEntity senderGlPznrEntity = new SenderGlPznrEntity();
		senderGlPznrEntity.setDataSourceCode(dataSourceCode);
		senderGlPznrEntity.setIdpzhs(idpzhs);
		List<SenderGlPznrEntity> list = senderGlPznrDao.querySenderGlPznrEntityByIdpzh(senderGlPznrEntity);
		if(list == null || list.size() == 0 ){
			return;
		}
		GlFzxzlEntityDto glFzxzlEntityDto = new GlFzxzlEntityDto();
		glFzxzlEntityDto.setDataSourceCode(dataSourceCode);
		glFzxzlEntityDto.setSfyz("0");
		List<GlFzxzlNrEntityDto> glFzxzlNrEntityDtos = new ArrayList<>();
		for (int i = 0; i < list.size(); i++) {
			if(list.get(i).getKjqj() != null && list.get(i).getKjqj().length() >= 4){
				GlFzxzlNrEntityDto glFzxzlNrEntityDto = new GlFzxzlNrEntityDto();
				glFzxzlNrEntityDto.setGsdm(list.get(i).getGsdm());
				glFzxzlNrEntityDto.setKjnd(list.get(i).getKjqj().substring(0,4));
				List<GlFzxzlNrDmEntityDto> glFzxzlNrDmEntityDtos = new ArrayList<>();

				if(list.get(i).getFzhs() != null && !"".equals(list.get(i).getFzhs())){
					JSONObject jsonObject = (JSONObject) JSONObject.toJSON(list.get(i));
					String[] fzhs = list.get(i).getFzhs().split(",");
					if(fzhs != null && fzhs.length > 0){
						for (int i1 = 0; i1 < fzhs.length; i1++) {
							if(fzhs[i1] != null && !"".equals(fzhs[i1])){
								if(jsonObject.get("fzdm"+fzhs[i1]) != null && !"".equals(jsonObject.get("fzdm"+fzhs[i1]))){
									GlFzxzlNrDmEntityDto glFzxzlNrDmEntityDto = new GlFzxzlNrDmEntityDto();
									glFzxzlNrDmEntityDto.setLbdm(fzhs[i1]);
									glFzxzlNrDmEntityDto.setFzdm(jsonObject.getString("fzdm"+fzhs[i1]));
									glFzxzlNrDmEntityDtos.add(glFzxzlNrDmEntityDto);
								}
							}
						}
					}
				}
				if(glFzxzlNrDmEntityDtos.size() > 0){
					glFzxzlNrEntityDto.setGlFzxzlNrDmEntityDtos(glFzxzlNrDmEntityDtos);
					glFzxzlNrEntityDtos.add(glFzxzlNrEntityDto);
				}
			}
		}
		if(glFzxzlNrEntityDtos.size() > 0) {
			glFzxzlEntityDto.setGlFzxzlNrEntityDtos(glFzxzlNrEntityDtos);
			// 查询数据，设置值
			List<JSONObject> fzhss = glFzxzlDao.queryFzhs(glFzxzlEntityDto);
			if(fzhss != null && fzhss.size() > 0){
				for (int i = 0; i < list.size(); i++) {
					List<JSONObject> fzhslist = new ArrayList<>();
					list.get(i).setFzhslist(fzhslist);
					if (list.get(i).getKjqj() != null && list.get(i).getKjqj().length() >= 4) {
						if (list.get(i).getFzhs() != null && !"".equals(list.get(i).getFzhs())) {
							JSONObject jsonObject = (JSONObject) JSONObject.toJSON(list.get(i));
							String[] fzhs = list.get(i).getFzhs().split(",");
							if (fzhs != null && fzhs.length > 0) {
								for (int i1 = 0; i1 < fzhs.length; i1++) {
									if (fzhs[i1] != null && !"".equals(fzhs[i1])) {
										if (jsonObject.get("fzdm" + fzhs[i1]) != null && !"".equals(jsonObject.get("fzdm" + fzhs[i1]))) {
											for (int i2 = 0; i2 < fzhss.size(); i2++) {
												if(fzhss.get(i2).getString("lbdm").equals(fzhs[i1])
														&&	fzhss.get(i2).getString("gsdm").equals(list.get(i).getGsdm())
														&&	fzhss.get(i2).getString("kjnd").equals(list.get(i).getKjqj().substring(0,4))
														&&	fzhss.get(i2).getString("fzdm").equals(jsonObject.get("fzdm" + fzhs[i1]))
												){
													JSONObject a = new JSONObject();
													a.put("lbdm",fzhss.get(i2).getString("lbdm"));
													a.put("fzdm",fzhss.get(i2).getString("fzdm"));
													a.put("fzmc",fzhss.get(i2).getString("fzmc"));
													fzhslist.add(a);
												}

											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

		for (int i = 0; i < senderGlPzmlEntities.size(); i++) {
			List<SenderGlPznrEntity> senderGlPznrEntities = new ArrayList<>();
			for (int i1 = 0; i1 < list.size(); i1++) {
				if(senderGlPzmlEntities.get(i).getIdpzh().equals(list.get(i1).getIdpzh())){
					senderGlPznrEntities.add(list.get(i1));
				}
			}
			senderGlPzmlEntities.get(i).setSenderGlPznrEntities(senderGlPznrEntities);
		}
	}
}
