package com.hzya.frame.grpU8.nxproof.glfzxzl.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.grpU8.nxproof.glfzxzl.dao.IGlFzxzlDao;
import com.hzya.frame.grpU8.nxproof.glfzxzl.entity.GlFzxzlEntity;
import com.hzya.frame.grpU8.nxproof.glfzxzl.service.IGlFzxzlService;
import com.hzya.frame.grpU8.nxproof.pubkszl.entity.PubkszlEntity;
import com.hzya.frame.web.entity.BaseResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * (GlFzxzl)表服务实现类
 *
 * @author makejava
 * @since 2024-08-06 10:56:29
 */
@Service(value = "glFzxzlService")
public class GlFzxzlServiceImpl extends BaseService<GlFzxzlEntity, String> implements IGlFzxzlService {
     
    private IGlFzxzlDao glFzxzlDao;
    
    @Autowired
	public void setGlFzxzlDao(IGlFzxzlDao dao) {
		this.glFzxzlDao = dao;
		this.dao = dao;
	}

	//查询辅助项资料
	@Override
	public Object queryEntityPage(JSONObject json) {
		JSONObject jsonObject = json.getJSONObject("jsonStr");
		GlFzxzlEntity glFzxzlEntity = jsonObject.toJavaObject(GlFzxzlEntity.class);
		if(!checkStr(jsonObject.getString("kjnd"))){
			logger.info("========查询辅助项资料传递得会计年度为空==========");
			return BaseResult.getFailureMessageEntity("会计年度为空");
		}
		if(!checkStr(jsonObject.getString("gsdm"))){
			logger.info("========查询辅助项资料传递得公司代码为空==========");
			return BaseResult.getFailureMessageEntity("公司代码为空");
		}
		try {
			List<GlFzxzlEntity> glFzxzlEntities = glFzxzlDao.queryGlFzxzlEntity(glFzxzlEntity);
			PageInfo pageInfo=new PageInfo(glFzxzlEntities);
			JSONObject object=new JSONObject();
			object.put("pageInfo",pageInfo);
			object.put("status","200");
			return object;
		}catch (Exception e){
			logger.info("=======根据会计年度：{}，公司代码：{}查询辅助项资料失败======",jsonObject.getString("kjnd"),jsonObject.getString("gsdm"),e.getMessage());
			return BaseResult.getFailureMessageEntity("查询辅助项资料失败");
		}
	}
}
