package com.hzya.frame.grpU8.nxproof.glxjllxm.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.grpU8.nxproof.glxjllxm.entity.GlXjllxmEntity;
import com.hzya.frame.grpU8.nxproof.glxjllxm.dao.IGlXjllxmDao;
import com.hzya.frame.grpU8.nxproof.glxjllxm.service.IGlXjllxmService;
import com.hzya.frame.web.entity.BaseResult;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import javax.annotation.Resource;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.util.List;

/**
 * (GlXjllxm)表服务实现类
 *
 * @author makejava
 * @since 2024-08-27 15:58:38
 */
@Service(value = "GlXjllxmServiceImpl")
public class GlXjllxmServiceImpl extends BaseService<GlXjllxmEntity, String> implements IGlXjllxmService {
     
    private IGlXjllxmDao glXjllxmDao;
    
    @Autowired
	public void setGlXjllxmDao(IGlXjllxmDao dao) {
		this.glXjllxmDao = dao;
		this.dao = dao;
	}

	//分页查询现金流量项目数据
	@Override
	public Object queryEntityPage(JSONObject json) {
		JSONObject jsonObject = json.getJSONObject("jsonStr");
		GlXjllxmEntity glXjllxmEntity = jsonObject.toJavaObject(GlXjllxmEntity.class);
		if(!checkStr(jsonObject.getString("kjnd"))){
			logger.info("========查询现金流量项目数据传递得会计年度为空==========");
			return BaseResult.getFailureMessageEntity("会计年度为空");
		}
		if(!checkStr(jsonObject.getString("gsdm"))){
			logger.info("========查询现金流量项目数据传递得公司代码为空==========");
			return BaseResult.getFailureMessageEntity("公司代码为空");
		}
		try {
			List<GlXjllxmEntity> glXjllxmEntities = glXjllxmDao.queryGlXjllxmEntity(glXjllxmEntity);
			PageInfo pageInfo=new PageInfo(glXjllxmEntities);
			JSONObject object=new JSONObject();
			object.put("pageInfo",pageInfo);
			object.put("status","200");
			return object;
		}catch (Exception e){
			logger.info("=======根据会计年度：{}，公司代码：{}查询现金流量项目失败======",jsonObject.getString("kjnd"),jsonObject.getString("gsdm"),e.getMessage());
			return BaseResult.getFailureMessageEntity("查询现金流量项目失败");
		}
	}
}
