package com.hzya.frame.grpU8.nxproof.pubkszl.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.grpU8.nxproof.glxjllxm.entity.GlXjllxmEntity;
import com.hzya.frame.grpU8.nxproof.pubkszl.entity.PubkszlEntity;
import com.hzya.frame.grpU8.nxproof.pubkszl.dao.IPubkszlDao;
import com.hzya.frame.grpU8.nxproof.pubkszl.service.IPubkszlService;
import com.hzya.frame.web.entity.BaseResult;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import javax.annotation.Resource;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.util.List;

/**
 * (Pubkszl)表服务实现类
 *
 * @author makejava
 * @since 2024-08-27 15:56:54
 */
@Service(value = "PubkszlServiceImpl")
public class PubkszlServiceImpl extends BaseService<PubkszlEntity, String> implements IPubkszlService {
     
    private IPubkszlDao pubkszlDao;
    
    @Autowired
	public void setPubkszlDao(IPubkszlDao dao) {
		this.pubkszlDao = dao;
		this.dao = dao;
	}

	//分页查询往来单位数据
	@Override
	public Object queryEntityPage(JSONObject json) {
		JSONObject jsonObject = json.getJSONObject("jsonStr");
		PubkszlEntity pubkszlEntity = jsonObject.toJavaObject(PubkszlEntity.class);
		if(!checkStr(jsonObject.getString("kjnd"))){
			logger.info("========查询往来单位传递得会计年度为空==========");
			return BaseResult.getFailureMessageEntity("会计年度为空");
		}
		if(!checkStr(jsonObject.getString("gsdm"))){
			logger.info("========查询往来单位传递得公司代码为空==========");
			return BaseResult.getFailureMessageEntity("公司代码为空");
		}
		try {
			List<PubkszlEntity> pubkszlEntities = pubkszlDao.queryPubkszlEntity(pubkszlEntity);
			PageInfo pageInfo=new PageInfo(pubkszlEntities);
			JSONObject object=new JSONObject();
			object.put("pageInfo",pageInfo);
			object.put("status","200");
			return object;
		}catch (Exception e){
			logger.info("=======根据会计年度：{}，公司代码：{}查询往来单位失败======",jsonObject.getString("kjnd"),jsonObject.getString("gsdm"),e.getMessage());
			return BaseResult.getFailureMessageEntity("查询往来单位失败");
		}
	}

	@Override
	public Object saveEntity(JSONObject json) {
		return null;
	}

	@Override
	public Object updateEntity(JSONObject json) {
		return null;
	}

	@Override
	public Object deleteEntity(JSONObject json) {
		return null;
	}
}
