package com.hzya.frame.grpU8.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.grpU8.acctVouchInfo.entity.AcctVouchInfoEntity;
import com.hzya.frame.grpU8.acctVouchInfo.service.IAcctVouchInfoService;
import com.hzya.frame.grpU8.nxproof.glfzxzl.service.IGlFzxzlService;
import com.hzya.frame.grpU8.nxproof.glkmxx.service.ISenderGlKmxxService;
import com.hzya.frame.grpU8.nxproof.glxjllxm.service.IGlXjllxmService;
import com.hzya.frame.grpU8.nxproof.glxmzl.service.ISenderGlXmzlService;
import com.hzya.frame.grpU8.nxproof.pubbmxx.service.ISenderPubbmxxService;
import com.hzya.frame.grpU8.nxproof.pubkszl.service.IPubkszlService;
import com.hzya.frame.grpU8.service.IGrpU8Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service(value = "grpU8Service")
public class GrpU8ServiceImpl  implements IGrpU8Service {

	@Resource
	private IAcctVouchInfoService acctVouchInfoService;
	@Autowired
	private ISenderPubbmxxService senderPubbmxxService;
	@Autowired
	private IPubkszlService pubkszlService;
	@Autowired
	private IGlXjllxmService glXjllxmService;
	@Autowired
	private IGlFzxzlService glFzxzlService;
	@Autowired
	private ISenderGlXmzlService senderGlXmzlService;
	@Autowired
	private ISenderGlKmxxService senderGlKmxxService;

	@Override
	public Object queryData(JSONObject object) {
		JSONObject jsonObject = getData("jsonStr", object,JSONObject.class);
		if(jsonObject == null || jsonObject.get("queryType") == null || "".equals(jsonObject.getString("queryType"))){
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","false");
			returnObject.put("msg","请先传递查询类型");
			return returnObject;
		}
		if(jsonObject.get("dataSourceCode") == null || "".equals(jsonObject.getString("dataSourceCode"))){
			JSONObject returnObject = new JSONObject();
			returnObject.put("status","false");
			returnObject.put("msg","系统错误请联系管理员");
			return returnObject;
		}
		Object returnObject = null;
		switch (jsonObject.getString("queryType")){
			case "1"://往来单位查询接口
				returnObject = pubkszlService.queryEntityPage(object);
				break;
			case "2"://部门查询接口
				returnObject = acctVouchInfoService.queryData(object);
				break;
			case "3"://固定辅助核算项查询接口
				returnObject = glFzxzlService.queryEntityPage(object);
				break;
			case "4"://项目查询接口
				returnObject = senderGlXmzlService.queryEntityPage(object);
				break;
			case "5"://功能科目查询接口
				//功能科目是辅助项资料类别为4得数据
				if(jsonObject.getString("lbdm") !=null && jsonObject.getString("lbdm").equals("4")){
					returnObject = glFzxzlService.queryEntityPage(object);
				}
				break;
			case "6"://部门经济科目查询接口
				//部门经济科目是辅助项资料类别为5得数据
				if(jsonObject.getString("lbdm") !=null && jsonObject.getString("lbdm").equals("5")){
					returnObject = glFzxzlService.queryEntityPage(object);
				}
				break;
			case "7"://科目总账余额查询接口
				returnObject = senderGlKmxxService.queryKmxxLedgerBalance(object);
				break;
			case "8"://科目辅助余额查询接口
				break;
			case "9"://现金流量项目查询接口
				returnObject=glXjllxmService.queryEntityPage(object);
				break;
			case "10"://总账凭证查询接口   ml
				returnObject = acctVouchInfoService.queryPzml(object);
				break;
			case "11"://总账凭证查询分路接口 nr
				returnObject = acctVouchInfoService.queryPznr(object);
				break;
			case "12"://总账凭证单个查询接口 ml nr fzhs 单个
				returnObject = acctVouchInfoService.queryPz(object);
				break;
			case "13"://总账凭证查询分页接口 ml nr fzhs 分页
				returnObject = acctVouchInfoService.queryPzPage(object);
				break;
			default:
				JSONObject jsonObject1 = new JSONObject();
				jsonObject1.put("status","false");
				jsonObject1.put("msg","查询类型错误，请联系管理员");
				returnObject = jsonObject1;
				break;
		}
		return returnObject;
	}
	protected <T> T getData(String key, JSONObject jsonObject, Class<T> clz) {
		if (checkStr(jsonObject.getString(key)) ) {
			return jsonObject.getJSONObject(key).toJavaObject(clz);
		}
		return null;
	}
	/**
	 * @param str
	 * @return void
	 * @Author lvleigang
	 * @Description 校验字符串
	 * @Date 11:41 上午 2022/12/7
	 **/
	protected Boolean checkStr(String str) {
		Boolean flag = true;
		if (str == null || "".equals(str)) {
			flag = false;
		}
		return flag;
	}
}
